version: 2.1

orbs:
  python: circleci/python@1.2

jobs:
  build-and-test:
    docker:
      - image: cimg/python:3.8
    steps:
      - checkout
      - python/install-packages:
          pkg-manager: pip
      - python/install-packages:
          pip-dependency-file: test-requirements.txt
          pkg-manager: pip          
      - add_ssh_keys:
          fingerprints:
            - 6b:31:14:0e:9b:c6:5e:0c:8e:1e:88:7b:06:e2:4e:ee
      - run:
          name: Checkout dependencies
          command: |
            ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
            git submodule update --init --recursive
      - run: mkdir -p test-results
      - run:
          name: Run tests
          command: pytest --junitxml=test-results/junit.xml -o junit_family=legacy
      - store_test_results:
          path: test-results

workflows:
  checkin:
    jobs:
      - build-and-test

  nightly:
    jobs:
      - build-and-test
    triggers:
      - schedule:
          # Test everyday at midnight.
          cron: 0 0 * * *
          filters:
            branches:
              only: main
